var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Component, ElementRef, Input, Output, EventEmitter, OnChanges } from '@angular/core';
import { CommonModule } from '@angular/common';
export let Alert = class Alert extends OnChanges {
    constructor(_el) {
        super();
        this._el = _el;
        this.displayed = false;
        this.closeButton = true;
        this.type = 'success';
        this.closeDelay = 0;
        this.displayedChange = new EventEmitter();
    }
    ngOnChanges(event) {
        if (this.displayed && this._el.nativeElement.querySelector('.alert')) {
            let classes = this._el.nativeElement.querySelector('.alert').className;
            classes = classes.replace('fuel-ui-alert-fade-out', 'fuel-ui-alert-fade-in');
            this._el.nativeElement.querySelector('.alert').className = classes;
        }
        if (this.closeDelay > 0) {
            setTimeout(() => {
                this.close();
            }, this.closeDelay);
        }
    }
    close() {
        if (this._el.nativeElement.querySelector('.alert')) {
            let classes = this._el.nativeElement.querySelector('.alert').className;
            classes = classes.replace('fuel-ui-alert-fade-in', 'fuel-ui-alert-fade-out');
            this._el.nativeElement.querySelector('.alert').className = classes;
        }
        setTimeout(() => {
            this.displayed = false;
            this.displayedChange.next(null);
        }, 1000);
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Alert.prototype, "displayed", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Alert.prototype, "closeButton", void 0);
__decorate([
    Input(), 
    __metadata('design:type', String)
], Alert.prototype, "type", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Number)
], Alert.prototype, "closeDelay", void 0);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], Alert.prototype, "displayedChange", void 0);
Alert = __decorate([
    Component({
        selector: 'alert',
        template: "\n      <div\n          *ngIf=\"displayed\"\n          role=\"alert\"\n          class=\"alert fuel-ui-alert-fade-in\"\n          [ngClass]=\"{'alert-success': type === 'success', 'alert-info': type === 'info', 'alert-warning': type === 'warning', 'alert-danger': type === 'danger' }\" >\n          <button *ngIf=\"closeButton\" (click)=\"close()\" type=\"button\" class=\"close\" aria-label=\"Close\">\n              <span aria-hidden=\"true\">&#215;</span>\n              <span class=\"sr-only\">Close</span>\n          </button>\n          <ng-content></ng-content>\n      </div>\n    "
    }), 
    __metadata('design:paramtypes', [ElementRef])
], Alert);
export let FuiAlertModule = class FuiAlertModule {
};
FuiAlertModule = __decorate([
    NgModule({
        imports: [CommonModule],
        declarations: [Alert],
        exports: [Alert]
    }), 
    __metadata('design:paramtypes', [])
], FuiAlertModule);
