var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Component, Directive, Input, Output, QueryList, ContentChildren } from "@angular/core";
import { HostListener, EventEmitter } from "@angular/core";
import { trigger, state, style, transition, animate } from '@angular/core';
import { CommonModule } from "@angular/common";
export let OffCanvasMenuClose = class OffCanvasMenuClose {
    constructor() {
        this.close = new EventEmitter();
    }
    onClick(e) {
        this.close.next(null);
    }
};
__decorate([
    Output(), 
    __metadata('design:type', Object)
], OffCanvasMenuClose.prototype, "close", void 0);
__decorate([
    HostListener("click", ["$event"]), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [Object]), 
    __metadata('design:returntype', void 0)
], OffCanvasMenuClose.prototype, "onClick", null);
OffCanvasMenuClose = __decorate([
    Directive({
        selector: "[offCanvasMenuClose], .off-canvas-menu-close"
    }), 
    __metadata('design:paramtypes', [])
], OffCanvasMenuClose);
export let OffCanvasMenu = class OffCanvasMenu {
    constructor() {
        this.origin = "left";
        this.width = "25%";
        this.height = "25%";
        this.close = new EventEmitter();
        this.open = new EventEmitter();
        this.computedWidth = this.width;
        this.computedHeight = this.height;
        this.isOpen = false;
        this.overlayState = null;
        this.openState = null;
    }
    ngOnInit() {
    }
    ngAfterContentInit() {
        this.closeButtons.map(b => b.close.subscribe(() => this.toggleMenu()));
    }
    ngOnDestroy() {
    }
    toggleMenu() {
        this.isOpen = !this.isOpen;
        if (this.isOpen) {
            this.overlayState = "in";
            this.openState = "open";
            this.open.next(null);
        }
        else {
            this.overlayState = null;
            this.openState = null;
            this.close.next(null);
        }
        if (this.origin == "left" || this.origin == "right") {
            this.computedHeight = "100%";
            this.computedWidth = this.width;
        }
        else if (this.origin == "top" || this.origin == "bottom") {
            this.computedWidth = "100%";
            this.computedHeight = this.height;
        }
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Object)
], OffCanvasMenu.prototype, "origin", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Object)
], OffCanvasMenu.prototype, "width", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Object)
], OffCanvasMenu.prototype, "height", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], OffCanvasMenu.prototype, "close", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], OffCanvasMenu.prototype, "open", void 0);
__decorate([
    ContentChildren(OffCanvasMenuClose), 
    __metadata('design:type', QueryList)
], OffCanvasMenu.prototype, "closeButtons", void 0);
OffCanvasMenu = __decorate([
    Component({
        selector: "off-canvas-menu",
        template: "\n      <div *ngIf=\"isOpen\" [@fade]=\"overlayState\" class=\"off-canvas-menu-overlay\" \n          (click)=\"toggleMenu()\"></div>\n\n      <div *ngIf=\"isOpen\" [@open]=\"openState\" class=\"off-canvas-menu\"\n          [class.off-canvas-menu-left]=\"origin.toLowerCase() == 'left'\"\n          [class.off-canvas-menu-right]=\"origin.toLowerCase() == 'right'\"\n          [class.off-canvas-menu-top]=\"origin.toLowerCase() == 'top'\"\n          [class.off-canvas-menu-bottom]=\"origin.toLowerCase() == 'bottom'\"\n          [style.width]=\"computedWidth\"\n          [style.height]=\"computedHeight\">\n          <ng-content></ng-content>    \n      </div>\n    ",
        styles: ["\n      .off-canvas-menu-overlay {\n        display: block;\n        position: fixed;\n        top: 0;\n        right: 0;\n        bottom: 0;\n        left: 0;\n        z-index: 900;\n        background-color: #55595c;\n        opacity: 0; }\n\n      .off-canvas-menu {\n        display: block;\n        position: fixed;\n        z-index: 1000;\n        background-color: #fff; }\n        .off-canvas-menu.off-canvas-menu-left {\n          top: 0;\n          left: 0;\n          bottom: 0;\n          transform: translate(-100%, 0);\n          width: 75%; }\n        .off-canvas-menu.off-canvas-menu-right {\n          top: 0;\n          right: 0;\n          bottom: 0;\n          transform: translate(100%, 0);\n          width: 75%; }\n        .off-canvas-menu.off-canvas-menu-top {\n          top: 0;\n          left: 0;\n          right: 0;\n          transform: translate(0, -100%);\n          height: 75%; }\n        .off-canvas-menu.off-canvas-menu-bottom {\n          left: 0;\n          right: 0;\n          bottom: 0;\n          transform: translate(0, 100%);\n          height: 75%; }\n    "],
        directives: [OffCanvasMenuClose],
        animations: [
            trigger("open", [
                state("open", style({ transform: "translate(0,0)" })),
                transition("void => open", [animate("200ms ease")]),
                transition("open => void", [animate("200ms ease")])
            ]),
            trigger("fade", [
                state("in", style({ opacity: ".75" })),
                transition("void => in", [animate("200ms ease")]),
                transition("in => void", [animate("200ms ease")])
            ])
        ]
    }), 
    __metadata('design:paramtypes', [])
], OffCanvasMenu);
const offCanvasMenuDirectives = [
    OffCanvasMenu,
    OffCanvasMenuClose
];
export let FuiOffCanvasMenuModule = class FuiOffCanvasMenuModule {
};
FuiOffCanvasMenuModule = __decorate([
    NgModule({
        imports: [CommonModule],
        declarations: offCanvasMenuDirectives,
        exports: offCanvasMenuDirectives
    }), 
    __metadata('design:paramtypes', [])
], FuiOffCanvasMenuModule);
