"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
require("./NoUiSlider");
var Slider = (function () {
    function Slider(_element) {
        this._element = _element;
        this.background = "#E24932";
        this.height = "";
        this.width = "";
        this.orientation = "horizontal";
        this.direction = "ltr";
        this.behavior = "tap";
        this.pips = 5;
        this.pipDensity = 5;
        this.step = 1;
        this.decimals = 0;
        this.minValue = 0;
        this.maxValue = 100;
        this.margin = 10;
        this.value = 0;
        this.secondValue = null;
        this.debounceTime = 150;
        this.valueChange = new core_1.EventEmitter();
        this.secondValueChange = new core_1.EventEmitter();
        this.timeout = null;
    }
    Slider.prototype.update = function (val) {
        this.value = parseInt(val[0]);
        this.secondValue = val.length > 1 ? parseInt(val[1]) : null;
        this.valueChange.next(this.value);
        this.secondValueChange.next(this.secondValue);
        this.timeout = null;
    };
    ;
    Slider.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._sliderElement = this._element.nativeElement.children[0];
        if (this.orientation == 'vertical')
            this._sliderElement.style.height = this.height.length > 0
                ? this.height
                : "200px";
        if (this.orientation == 'horizontal')
            this._sliderElement.style.width = this.width.length > 0
                ? this.width
                : null; //full width
        this._slider = noUiSlider.create(this._sliderElement, {
            start: this.secondValue != null ? [this.value, this.secondValue] : this.value,
            step: parseInt(this.step.toString()),
            margin: this.margin,
            connect: this.secondValue != null ? true : 'lower',
            direction: this.direction,
            orientation: this.orientation,
            behaviour: this.behavior,
            range: {
                'min': parseInt(this.minValue.toString()),
                'max': parseInt(this.maxValue.toString())
            },
            pips: {
                mode: 'count',
                values: this.pips,
                density: this.pipDensity
            },
            format: {
                to: function (value) {
                    return parseFloat(value).toFixed(_this.decimals);
                },
                from: function (value) {
                    return parseFloat(value).toFixed(_this.decimals);
                }
            }
        });
        if (!this._element.nativeElement.disabled) {
            var noUI = this._element.nativeElement.getElementsByClassName('noUi-connect');
            //convert HTMLCollection to array to loop
            [].slice.call(noUI).forEach(function (el) {
                el.style.background = _this.background;
            });
        }
        this._sliderElement.noUiSlider.on('slide', function (val) {
            if (_this.timeout)
                clearTimeout(_this.timeout);
            _this.timeout = setTimeout(function () {
                _this.update(val);
            }, _this.debounceTime);
        });
        this._sliderElement.noUiSlider.on('end', function (val) {
            if (_this.timeout)
                clearTimeout(_this.timeout);
            _this.update(val);
        });
    };
    Slider.prototype.ngOnChanges = function (changes) {
        if (this._sliderElement && typeof changes.value !== 'undefined')
            this._sliderElement.noUiSlider.set([changes.value.currentValue, this.secondValue]);
        if (this._sliderElement && typeof changes.secondValue !== 'undefined')
            this._sliderElement.noUiSlider.set([this.value, changes.secondValue.currentValue]);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "background", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "height", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "width", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "orientation", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "direction", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Slider.prototype, "behavior", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "pips", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "pipDensity", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "step", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "decimals", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "minValue", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "maxValue", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "margin", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "value", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "secondValue", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Slider.prototype, "debounceTime", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], Slider.prototype, "valueChange", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], Slider.prototype, "secondValueChange", void 0);
    Slider = __decorate([
        core_1.Component({
            selector: "slider",
            template: "\n\n      <div class=\"slider\"></div>\n    "
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], Slider);
    return Slider;
}());
exports.Slider = Slider;
var FuiSliderModule = (function () {
    function FuiSliderModule() {
    }
    FuiSliderModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [Slider],
            exports: [Slider]
        }), 
        __metadata('design:paramtypes', [])
    ], FuiSliderModule);
    return FuiSliderModule;
}());
exports.FuiSliderModule = FuiSliderModule;

//# sourceMappingURL=Slider.js.map
