import {NgModule} from "@angular/core";
import {CommonModule} from "@angular/common";
import {FormsModule} from "@angular/forms";
import {FuelUiModule} from "../fuel-ui";

import {AccordionDemo} from "./Accordion/Accordion.Demo";
import {AlertDemo} from "./Alert/Alert.Demo";
import {CarouselDemo} from "./Carousel/Carousel.Demo";
import {DatePickerDemo} from "./DatePicker/DatePicker.Demo";
import {DateRangePickerDemo} from "./DatePicker/DateRangePicker.Demo";
import {DropdownDemo} from "./Dropdown/Dropdown.Demo";
import {InfiniteScrollerDemo} from "./InfiniteScroller/InfiniteScroller.Demo";
import {ModalDemo} from "./Modal/Modal.Demo";
import {OffCanvasMenuDemo} from "./OffCanvasMenu/OffCanvasMenu.Demo";
import {PaginationDemo} from "./Pagination/Pagination.Demo";
import {ProgressDemo} from "./Progress/Progress.Demo";
import {TableSortableDemo} from "./TableSortable/TableSortable.Demo";
import {SliderDemo} from "./Slider/Slider.Demo";
import {TabDemo} from "./Tab/Tab.Demo";
import {TagDemo} from "./Tag/Tag.Demo";
import {TimePickerDemo} from "./TimePicker/TimePicker.Demo";
import {TextExpanderDemo} from "./TextExpander/TextExpander.Demo";

export * from "./Accordion/Accordion.Demo";
export * from "./Alert/Alert.Demo";
export * from "./Carousel/Carousel.Demo";
export * from "./DatePicker/DatePicker.Demo";
export * from "./DatePicker/DateRangePicker.Demo";
export * from "./Dropdown/Dropdown.Demo";
export * from "./InfiniteScroller/InfiniteScroller.Demo";
export * from "./Modal/Modal.Demo";
export * from "./OffCanvasMenu/OffCanvasMenu.Demo";
export * from "./Pagination/Pagination.Demo";
export * from "./Progress/Progress.Demo";
export * from "./TableSortable/TableSortable.Demo";
export * from "./Slider/Slider.Demo";
export * from "./Tab/Tab.Demo";
export * from "./Tag/Tag.Demo";
export * from "./TimePicker/TimePicker.Demo";
export * from "./TextExpander/TextExpander.Demo";

const demoDirectives = [
    AccordionDemo,
    AlertDemo,
    CarouselDemo,
    DatePickerDemo,
    DateRangePickerDemo,
    DropdownDemo,
    InfiniteScrollerDemo,
    ModalDemo,
    OffCanvasMenuDemo,
    PaginationDemo,
    ProgressDemo,
    TableSortableDemo,
    SliderDemo,
    TabDemo,
    TagDemo,
    TimePickerDemo,
    TextExpanderDemo
]

@NgModule({
    imports: [
        CommonModule,
        FormsModule,
        FuelUiModule
    ],
    declarations: demoDirectives,
    exports: demoDirectives
})
export class FuiComponentsDemoModule { }